diff --git a/src/SybaseASE_fmt_plug.c b/src/SybaseASE_fmt_plug.c
index 849116221b..b1af7dbb4f 100644
--- a/src/SybaseASE_fmt_plug.c
+++ b/src/SybaseASE_fmt_plug.c
@@ -131,7 +131,7 @@ static void init(struct fmt_main *self)
 		fmt_SybaseASE.params.plaintext_length = 125;
 	// will simply set SIMD stuff here, even if not 'used'
 #ifdef SIMD_COEF_32
-	NULL_LIMB = mem_calloc_tiny(64*MAX_KEYS_PER_CRYPT, MEM_ALIGN_CACHE);
+	NULL_LIMB = mem_calloc_align(64, MAX_KEYS_PER_CRYPT, MEM_ALIGN_CACHE);
 	last_len = mem_calloc_align(sizeof(*last_len), self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	for (i = 0; i < kpc/MAX_KEYS_PER_CRYPT; ++i) {
 		int j;
@@ -145,9 +145,10 @@ static void init(struct fmt_main *self)
 
 static void done(void)
 {
-	MEM_FREE(prep_key);
-	MEM_FREE(crypt_out);
 	MEM_FREE(last_len);
+	MEM_FREE(NULL_LIMB);
+	MEM_FREE(crypt_out);
+	MEM_FREE(prep_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
diff --git a/src/office_common_plug.c b/src/office_common_plug.c
index 4cdcc640c6..fd0569bc59 100644
--- a/src/office_common_plug.c
+++ b/src/office_common_plug.c
@@ -19,9 +19,10 @@ void *ms_office_common_get_salt(char *ciphertext)
 	int i, length;
 	char *ctcopy = strdup(ciphertext);
 	char *keeptr = ctcopy, *p;
-	ms_office_custom_salt *cur_salt;
+	static ms_office_custom_salt *cur_salt;
 
-	cur_salt = mem_calloc_tiny(sizeof(ms_office_custom_salt), MEM_ALIGN_WORD);
+	if (!cur_salt) cur_salt = mem_calloc_tiny(sizeof(ms_office_custom_salt), MEM_ALIGN_WORD);
+	memset(cur_salt, 0, sizeof(*cur_salt));
 	ctcopy += 9;	/* skip over "$office$*" */
 	p = strtokm(ctcopy, "*");
 	cur_salt->version = atoi(p);
diff --git a/src/office_fmt_plug.c b/src/office_fmt_plug.c
index d7b896e365..177bad3d43 100644
--- a/src/office_fmt_plug.c
+++ b/src/office_fmt_plug.c
@@ -537,18 +537,22 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-	                            self->params.max_keys_per_crypt, sizeof(UTF16));
-	saved_len = mem_calloc_tiny(sizeof(*saved_len) *
-	                            self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_key = mem_calloc_tiny(sizeof(*crypt_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	cracked = mem_calloc_tiny(sizeof(*cracked) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	saved_len = mem_calloc(sizeof(*saved_len), self->params.max_keys_per_crypt);
+	crypt_key = mem_calloc(sizeof(*crypt_key), self->params.max_keys_per_crypt);
+	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 	if (pers_opts.target_enc == UTF_8)
 		self->params.plaintext_length = MIN(125, PLAINTEXT_LENGTH * 3);
 }
 
+static void done(void)
+{
+	MEM_FREE(cracked);
+	MEM_FREE(crypt_key);
+	MEM_FREE(saved_len);
+	MEM_FREE(saved_key);
+}
+
 static void set_salt(void *salt)
 {
 	cur_salt = (ms_office_custom_salt *)salt;
@@ -690,7 +694,7 @@ struct fmt_main fmt_office = {
 		office_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		ms_office_common_valid_all,
diff --git a/src/openbsdsoftraid_fmt_plug.c b/src/openbsdsoftraid_fmt_plug.c
index 90b775e378..7bbb3bda35 100644
--- a/src/openbsdsoftraid_fmt_plug.c
+++ b/src/openbsdsoftraid_fmt_plug.c
@@ -78,9 +78,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	key_buffer = mem_calloc_tiny(sizeof(*key_buffer) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) * self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	key_buffer = mem_calloc(sizeof(*key_buffer), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(key_buffer);
 }
 
 static int valid(char* ciphertext, struct fmt_main *self)
@@ -308,7 +313,7 @@ struct fmt_main fmt_openbsd_softraid = {
 		tests_openbsdsoftraid
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/opencl_keychain_fmt_plug.c b/src/opencl_keychain_fmt_plug.c
index a49e1099b6..bab60a3a19 100644
--- a/src/opencl_keychain_fmt_plug.c
+++ b/src/opencl_keychain_fmt_plug.c
@@ -247,8 +247,10 @@ static void *get_salt(char *ciphertext)
 	char *keeptr = ctcopy;
 	int i;
 	char *p;
+	static struct custom_salt *salt_struct;
 
-	salt_struct = mem_calloc_tiny(sizeof(struct custom_salt),
+	if (!salt_struct)
+		salt_struct = mem_calloc_tiny(sizeof(struct custom_salt),
 	                              MEM_ALIGN_WORD);
 	ctcopy += 11;	/* skip over "$keychain$*" */
 	p = strtokm(ctcopy, "*");
diff --git a/src/oracle11_fmt_plug.c b/src/oracle11_fmt_plug.c
index 8c3f00c158..81d3856a25 100644
--- a/src/oracle11_fmt_plug.c
+++ b/src/oracle11_fmt_plug.c
@@ -140,8 +140,8 @@ static void init(struct fmt_main *self)
 #ifdef SIMD_COEF_32
 	unsigned int i;
 
-	saved_key = mem_calloc_tiny(SHA_BUF_SIZ * 4 * NBKEYS, MEM_ALIGN_SIMD);
-	crypt_key = mem_calloc_tiny(BINARY_SIZE * NBKEYS, MEM_ALIGN_SIMD);
+	saved_key = mem_calloc_align(SHA_BUF_SIZ * 4, NBKEYS, MEM_ALIGN_SIMD);
+	crypt_key = mem_calloc_align(BINARY_SIZE, NBKEYS, MEM_ALIGN_SIMD);
 	/* Set lengths to SALT_LEN to avoid strange things in crypt_all()
 	   if called without setting all keys (in benchmarking). Unset
 	   keys would otherwise get a length of -10 and a salt appended
@@ -149,7 +149,14 @@ static void init(struct fmt_main *self)
 	for (i=0; i < NBKEYS; i++)
 		((unsigned int *)saved_key)[15*SIMD_COEF_32 + (i&(SIMD_COEF_32-1)) + i/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32] = 10 << 3;
 #endif
-	saved_salt = mem_calloc_tiny(SALT_SIZE, MEM_ALIGN_WORD);
+	saved_salt = mem_calloc(1, SALT_SIZE);
+}
+
+static void done(void)
+{
+	MEM_FREE(saved_salt);
+	MEM_FREE(crypt_key);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -434,7 +441,7 @@ struct fmt_main fmt_oracle11 = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/panama_fmt_plug.c b/src/panama_fmt_plug.c
index 7581af4698..47d2cbf959 100644
--- a/src/panama_fmt_plug.c
+++ b/src/panama_fmt_plug.c
@@ -74,11 +74,15 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) * self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 }
 
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_key);
+}
 
 static int valid(char *ciphertext, struct fmt_main *self)
 {
@@ -213,7 +217,7 @@ struct fmt_main fmt_panama_ = {
 		panama__tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		prepare,
 		valid,
diff --git a/src/pbkdf2-hmac-sha512_fmt_plug.c b/src/pbkdf2-hmac-sha512_fmt_plug.c
index be1812b1d7..b4c37718c9 100644
--- a/src/pbkdf2-hmac-sha512_fmt_plug.c
+++ b/src/pbkdf2-hmac-sha512_fmt_plug.c
@@ -112,10 +112,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-	        self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) *
-	        self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -403,7 +407,7 @@ struct fmt_main fmt_pbkdf2_hmac_sha512 = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		prepare,
 		valid,
diff --git a/src/pdf_fmt_plug.c b/src/pdf_fmt_plug.c
index 24ad502b77..0ee4dbe90a 100644
--- a/src/pdf_fmt_plug.c
+++ b/src/pdf_fmt_plug.c
@@ -103,11 +103,16 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	any_cracked = 0;
 	cracked_size = sizeof(*cracked) * self->params.max_keys_per_crypt;
-	cracked = mem_calloc_tiny(cracked_size, MEM_ALIGN_WORD);
+	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(cracked);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -683,7 +688,7 @@ struct fmt_main fmt_pdf = {
 	},
 	{
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		prepare,
 		valid,
diff --git a/src/pkzip_fmt_plug.c b/src/pkzip_fmt_plug.c
index 4e9a98d6bd..cd011b26c2 100644
--- a/src/pkzip_fmt_plug.c
+++ b/src/pkzip_fmt_plug.c
@@ -361,12 +361,9 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	K12 = mem_calloc_tiny(sizeof(*K12) * 3 *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	chk = mem_calloc_tiny(sizeof(*chk) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	K12 = mem_calloc(sizeof(*K12) * 3, self->params.max_keys_per_crypt);
+	chk = mem_calloc(sizeof(*chk), self->params.max_keys_per_crypt);
 
 	/*
 	 * Precompute the multiply mangling, within several parts of the hash. There is a pattern,
@@ -475,6 +472,13 @@ static void init(struct fmt_main *self)
 #endif
 }
 
+static void done(void)
+{
+	MEM_FREE(chk);
+	MEM_FREE(K12);
+	MEM_FREE(saved_key);
+}
+
 static void set_salt(void *_salt) {
 	salt = *((PKZ_SALT**)_salt);
 	if (salt->H[0].h && salt->H[1].h && salt->H[2].h)
@@ -1665,7 +1669,7 @@ struct fmt_main fmt_pkzip = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/pwsafe_fmt_plug.c b/src/pwsafe_fmt_plug.c
index fd1747f5ea..e1cff7a31f 100644
--- a/src/pwsafe_fmt_plug.c
+++ b/src/pwsafe_fmt_plug.c
@@ -91,9 +91,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) * self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -648,7 +653,7 @@ struct fmt_main fmt_pwsafe = {
 		pwsafe_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/rar5_fmt_plug.c b/src/rar5_fmt_plug.c
index b5ba6e02ab..6c904b2b77 100644
--- a/src/rar5_fmt_plug.c
+++ b/src/rar5_fmt_plug.c
@@ -80,9 +80,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) * self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_key);
 }
 
 static void set_salt(void *salt)
@@ -173,7 +178,7 @@ struct fmt_main fmt_rar5 = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/rar_fmt_plug.c b/src/rar_fmt_plug.c
index 2e36d68839..1c77d77327 100644
--- a/src/rar_fmt_plug.c
+++ b/src/rar_fmt_plug.c
@@ -146,7 +146,7 @@ static void init(struct fmt_main *self)
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_len));
 	if (!saved_salt)
-		saved_salt = mem_calloc_tiny(8, MEM_ALIGN_NONE);
+		saved_salt = mem_calloc(8, 1);
 	aes_key = mem_calloc(self->params.max_keys_per_crypt, 16);
 	aes_iv = mem_calloc(self->params.max_keys_per_crypt, 16);
 
@@ -177,6 +177,7 @@ static void done(void)
 	MEM_FREE(saved_key);
 	MEM_FREE(cracked);
 	MEM_FREE(unpack_data);
+	MEM_FREE(saved_salt);
 }
 
 static int crypt_all(int *pcount, struct db_salt *salt)
diff --git a/src/rawSHA512_common_plug.c b/src/rawSHA512_common_plug.c
index 56e686108d..5ddf209427 100644
--- a/src/rawSHA512_common_plug.c
+++ b/src/rawSHA512_common_plug.c
@@ -99,8 +99,8 @@ char * sha512_common_prepare_xsha(char *split_fields[10], struct fmt_main *self)
 		sprintf(Buf, "%s%s", XSHA512_FORMAT_TAG, split_fields[0]);
 
 		if (sha512_common_valid_xsha(Buf, self)) {
-			char *cp = mem_calloc_tiny(XSHA512_CIPHERTEXT_LENGTH+7,
-				MEM_ALIGN_NONE);
+			static char *cp;
+			if (!cp) cp = mem_calloc_tiny(XSHA512_CIPHERTEXT_LENGTH+7, 1);
 			strcpy(cp, Buf);
 			return cp;
 		}
@@ -109,8 +109,8 @@ char * sha512_common_prepare_xsha(char *split_fields[10], struct fmt_main *self)
 		sprintf(Buf, "%s%s", XSHA512_FORMAT_TAG, split_fields[1]);
 
 		if (sha512_common_valid_xsha(Buf, self)) {
-			char *cp = mem_calloc_tiny(XSHA512_CIPHERTEXT_LENGTH+7,
-				MEM_ALIGN_NONE);
+			static char *cp;
+			if (!cp) cp = mem_calloc_tiny(XSHA512_CIPHERTEXT_LENGTH+7, 1);
 			strcpy(cp, Buf);
 			return cp;
 		}
diff --git a/src/rawmd5u_fmt_plug.c b/src/rawmd5u_fmt_plug.c
index 07acd7f702..976ced2ada 100644
--- a/src/rawmd5u_fmt_plug.c
+++ b/src/rawmd5u_fmt_plug.c
@@ -128,14 +128,21 @@ static void init(struct fmt_main *self)
 		}
 	}
 #if SIMD_COEF_32
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) * 64*self->params.max_keys_per_crypt, MEM_ALIGN_SIMD);
-	crypt_key = mem_calloc_tiny(sizeof(*crypt_key) * BINARY_SIZE*self->params.max_keys_per_crypt, MEM_ALIGN_SIMD);
-	buf_ptr = mem_calloc_tiny(sizeof(*buf_ptr) * self->params.max_keys_per_crypt, sizeof(*buf_ptr));
+	saved_key = mem_calloc_align(sizeof(*saved_key), 64*self->params.max_keys_per_crypt, MEM_ALIGN_SIMD);
+	crypt_key = mem_calloc_align(sizeof(*crypt_key), BINARY_SIZE*self->params.max_keys_per_crypt, MEM_ALIGN_SIMD);
+	buf_ptr = mem_calloc_align(sizeof(*buf_ptr), self->params.max_keys_per_crypt, sizeof(*buf_ptr));
 	for (i=0; i<self->params.max_keys_per_crypt; i++)
 		buf_ptr[i] = (unsigned int*)&saved_key[GETPOS(0, i)];
 #endif
 }
 
+static void done(void)
+{
+	MEM_FREE(buf_ptr);
+	MEM_FREE(crypt_key);
+	MEM_FREE(saved_key);
+}
+
 static char *split(char *ciphertext, int index, struct fmt_main *self)
 {
 	static char out[32+12+1];
@@ -611,7 +618,7 @@ struct fmt_main fmt_rawmd5uthick = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/skein_fmt_plug.c b/src/skein_fmt_plug.c
index b42856b049..868de0302c 100644
--- a/src/skein_fmt_plug.c
+++ b/src/skein_fmt_plug.c
@@ -92,9 +92,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) * self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self, int len)
@@ -296,7 +301,7 @@ struct fmt_main fmt_skein_256 = {
 		skein_256_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		prepare,
 		valid256,
@@ -357,7 +362,7 @@ struct fmt_main fmt_skein_512 = {
 		skein_512_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		prepare,
 		valid512,
diff --git a/src/ssh_fmt_plug.c b/src/ssh_fmt_plug.c
index 8174d9f4fd..d36313522b 100644
--- a/src/ssh_fmt_plug.c
+++ b/src/ssh_fmt_plug.c
@@ -119,11 +119,16 @@ static void init(struct fmt_main *self)
 		self->params.max_keys_per_crypt *= omp_t;
 	}
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key),self->params.max_keys_per_crypt);
 	any_cracked = 0;
 	cracked_size = sizeof(*cracked) * self->params.max_keys_per_crypt;
-	cracked = mem_calloc_tiny(cracked_size, MEM_ALIGN_WORD);
+	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(cracked);
+	MEM_FREE(saved_key);
 }
 
 #define M_do_cipher(ctx, out, in, inl) ctx->cipher->do_cipher(ctx, out, in, inl)
@@ -506,7 +511,7 @@ struct fmt_main fmt_ssh = {
 		ssh_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/strip_fmt_plug.c b/src/strip_fmt_plug.c
index 94ac9edafc..f6cd6b8e31 100644
--- a/src/strip_fmt_plug.c
+++ b/src/strip_fmt_plug.c
@@ -87,10 +87,14 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	cracked = mem_calloc_tiny(sizeof(*cracked) *
-			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(cracked);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -285,7 +289,7 @@ struct fmt_main fmt_strip = {
 		strip_tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
diff --git a/src/sunmd5_fmt_plug.c b/src/sunmd5_fmt_plug.c
index 0cd4dc406d..85fd7239fc 100644
--- a/src/sunmd5_fmt_plug.c
+++ b/src/sunmd5_fmt_plug.c
@@ -259,8 +259,7 @@ static void init(struct fmt_main *self)
 #endif
 
 	saved_key = mem_calloc(self->params.max_keys_per_crypt, sizeof(*saved_key));
-	if (!saved_salt)
-		saved_salt = mem_calloc_tiny(SALT_SIZE + 1, MEM_ALIGN_WORD);
+	saved_salt = mem_calloc(1, SALT_SIZE + 1);
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt, sizeof(*crypt_out));
 	data = mem_calloc_align(self->params.max_keys_per_crypt, sizeof(*data), MEM_ALIGN_CACHE);
 
@@ -270,14 +269,15 @@ static void init(struct fmt_main *self)
 
 static void done(void)
 {
+	MEM_FREE(data);
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_salt);
+	MEM_FREE(saved_key);
 #ifdef SIMD_COEF_32
 	MEM_FREE(input_buf);
 	MEM_FREE(input_buf_big);
 	MEM_FREE(out_buf);
 #endif
-	MEM_FREE(crypt_out);
-	MEM_FREE(saved_key);
-	MEM_FREE(data);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
diff --git a/src/vtp_fmt_plug.c b/src/vtp_fmt_plug.c
index 5b6d14321e..6600ebf683 100644
--- a/src/vtp_fmt_plug.c
+++ b/src/vtp_fmt_plug.c
@@ -104,12 +104,16 @@ static void init(struct fmt_main *self)
 	omp_t *= OMP_SCALE;
 	self->params.max_keys_per_crypt *= omp_t;
 #endif
-	saved_key = mem_calloc_tiny(sizeof(*saved_key) *
-		self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	saved_len = mem_calloc_tiny(sizeof(*saved_len) *
-		self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
-	crypt_out = mem_calloc_tiny(sizeof(*crypt_out) *
-		self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
+	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
+	saved_len = mem_calloc(sizeof(*saved_len), self->params.max_keys_per_crypt);
+	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
+}
+
+static void done(void)
+{
+	MEM_FREE(crypt_out);
+	MEM_FREE(saved_len);
+	MEM_FREE(saved_key);
 }
 
 static int valid(char *ciphertext, struct fmt_main *self)
@@ -423,7 +427,7 @@ struct fmt_main fmt_vtp = {
 		tests
 	}, {
 		init,
-		fmt_default_done,
+		done,
 		fmt_default_reset,
 		fmt_default_prepare,
 		valid,
